<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ospi2urdf: osim2urdf_parser Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">ospi2urdf
   </div>
   <div id="projectbrief">Express .osim files as .urdf files.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">osim2urdf_parser Namespace Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classosim2urdf__parser_1_1Osim2URDF.html">Osim2URDF</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Transform a .osim file into a .urdf file.  <a href="classosim2urdf__parser_1_1Osim2URDF.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a27d2053729ad17e5d5c5dd3aa4ae74a4"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a27d2053729ad17e5d5c5dd3aa4ae74a4">readJoint</a> (name_joint, pymodel, bodies, body_name)</td></tr>
<tr class="memdesc:a27d2053729ad17e5d5c5dd3aa4ae74a4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read all joints of type "name_joint" belonging to body object "bodies", of name "body_name".  <a href="#a27d2053729ad17e5d5c5dd3aa4ae74a4">More...</a><br /></td></tr>
<tr class="separator:a27d2053729ad17e5d5c5dd3aa4ae74a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a80361136bd7e3bc9e7ece1768118a430"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a80361136bd7e3bc9e7ece1768118a430">readJointSet</a> (root, pymodel)</td></tr>
<tr class="memdesc:a80361136bd7e3bc9e7ece1768118a430"><td class="mdescLeft">&#160;</td><td class="mdescRight">Special case where the .osim file got a "JointSet" tag.  <a href="#a80361136bd7e3bc9e7ece1768118a430">More...</a><br /></td></tr>
<tr class="separator:a80361136bd7e3bc9e7ece1768118a430"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49fac8e7a12c5b6df7b7ab737e06cf4e"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a49fac8e7a12c5b6df7b7ab737e06cf4e">readOsim</a> (<a class="el" href="namespaceosim2urdf__parser.html#a3a1a90139c2c8ab1fca0ea8b1790b7b2">filename</a>)</td></tr>
<tr class="memdesc:a49fac8e7a12c5b6df7b7ab737e06cf4e"><td class="mdescLeft">&#160;</td><td class="mdescRight">First method called to read .osim files.  <a href="#a49fac8e7a12c5b6df7b7ab737e06cf4e">More...</a><br /></td></tr>
<tr class="separator:a49fac8e7a12c5b6df7b7ab737e06cf4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a11cecbea7159fc52d0581507d386b705"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a11cecbea7159fc52d0581507d386b705">readOsim30</a> (<a class="el" href="namespaceosim2urdf__parser.html#a3a1a90139c2c8ab1fca0ea8b1790b7b2">filename</a>)</td></tr>
<tr class="memdesc:a11cecbea7159fc52d0581507d386b705"><td class="mdescLeft">&#160;</td><td class="mdescRight">Based on the method readOsim of the Ospi package, this method is improved in order to be able to read a larger number of .osim files.  <a href="#a11cecbea7159fc52d0581507d386b705">More...</a><br /></td></tr>
<tr class="separator:a11cecbea7159fc52d0581507d386b705"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad1c7b3a585da1da7552f82ba917b2462"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#ad1c7b3a585da1da7552f82ba917b2462">readOsim40</a> (<a class="el" href="namespaceosim2urdf__parser.html#a3a1a90139c2c8ab1fca0ea8b1790b7b2">filename</a>)</td></tr>
<tr class="memdesc:ad1c7b3a585da1da7552f82ba917b2462"><td class="mdescLeft">&#160;</td><td class="mdescRight">Based on the method readOsim of the Ospi package, this method is improved in order to be able to read a larger number of .osim files.  <a href="#ad1c7b3a585da1da7552f82ba917b2462">More...</a><br /></td></tr>
<tr class="separator:ad1c7b3a585da1da7552f82ba917b2462"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeea41d0e48e9cd3fdc78c3e05b200ab5"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#aeea41d0e48e9cd3fdc78c3e05b200ab5">readVisuals40</a> (pymodel, bodies)</td></tr>
<tr class="memdesc:aeea41d0e48e9cd3fdc78c3e05b200ab5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Method used to read visual information of a body part "bodies" (linked to the geometry file used to represent the body part : name of the geometry part, scale factors, ...).  <a href="#aeea41d0e48e9cd3fdc78c3e05b200ab5">More...</a><br /></td></tr>
<tr class="separator:aeea41d0e48e9cd3fdc78c3e05b200ab5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26ad97fd20c03ddf7aae5cb9f17a385a"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a26ad97fd20c03ddf7aae5cb9f17a385a">readVisualsName40</a> (name, visuals_data, bones_data, bodies)</td></tr>
<tr class="memdesc:a26ad97fd20c03ddf7aae5cb9f17a385a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Method used to read visual informations, written under a tag "name", of a body part "bodies".  <a href="#a26ad97fd20c03ddf7aae5cb9f17a385a">More...</a><br /></td></tr>
<tr class="separator:a26ad97fd20c03ddf7aae5cb9f17a385a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0be355dde18c1660f40705263e2d56a5"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a0be355dde18c1660f40705263e2d56a5">VTP2STL</a> (path_vtp, path_stl)</td></tr>
<tr class="separator:a0be355dde18c1660f40705263e2d56a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a02e8f4b0e11846d789ef52456f89e4af"><td class="memItemLeft" align="right" valign="top">dictionary&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a02e8f4b0e11846d789ef52456f89e4af">correc_stl_dic</a></td></tr>
<tr class="memdesc:a02e8f4b0e11846d789ef52456f89e4af"><td class="mdescLeft">&#160;</td><td class="mdescRight">Used to correct the positions of the .stl files.  <a href="#a02e8f4b0e11846d789ef52456f89e4af">More...</a><br /></td></tr>
<tr class="separator:a02e8f4b0e11846d789ef52456f89e4af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a985b7dbc4e56a68aee3e904a61c2371b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a985b7dbc4e56a68aee3e904a61c2371b">exactly_collision</a> = False</td></tr>
<tr class="memdesc:a985b7dbc4e56a68aee3e904a61c2371b"><td class="mdescLeft">&#160;</td><td class="mdescRight">True : try to represent the collision aspect of the model from the .stl files.  <a href="#a985b7dbc4e56a68aee3e904a61c2371b">More...</a><br /></td></tr>
<tr class="separator:a985b7dbc4e56a68aee3e904a61c2371b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab77d3043b16b1f346c6f99a984c92409"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#ab77d3043b16b1f346c6f99a984c92409">exactly_visual</a> = True</td></tr>
<tr class="memdesc:ab77d3043b16b1f346c6f99a984c92409"><td class="mdescLeft">&#160;</td><td class="mdescRight">True : try to represent the visual aspect of the model from the .stl files.  <a href="#ab77d3043b16b1f346c6f99a984c92409">More...</a><br /></td></tr>
<tr class="separator:ab77d3043b16b1f346c6f99a984c92409"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3a1a90139c2c8ab1fca0ea8b1790b7b2"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a3a1a90139c2c8ab1fca0ea8b1790b7b2">filename</a> = 'TwoArm_7ddOS4.osim'</td></tr>
<tr class="memdesc:a3a1a90139c2c8ab1fca0ea8b1790b7b2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Name of the .osim file.  <a href="#a3a1a90139c2c8ab1fca0ea8b1790b7b2">More...</a><br /></td></tr>
<tr class="separator:a3a1a90139c2c8ab1fca0ea8b1790b7b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7158fb745d46e2beedea849918833689"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a7158fb745d46e2beedea849918833689">o2u</a> = <a class="el" href="classosim2urdf__parser_1_1Osim2URDF.html">Osim2URDF</a>(<a class="el" href="namespaceosim2urdf__parser.html#a556bc2189083b93f7852f14b81846c90">osim_path</a>, <a class="el" href="namespaceosim2urdf__parser.html#a0a1ad1e94acfcc8c3b00d794d52d7e75">vtp_path</a>, <a class="el" href="namespaceosim2urdf__parser.html#a3a1a90139c2c8ab1fca0ea8b1790b7b2">filename</a>, <a class="el" href="namespaceosim2urdf__parser.html#a8161856d320b780394891de051cc0133">ros_package_path</a>, <a class="el" href="namespaceosim2urdf__parser.html#ab77d3043b16b1f346c6f99a984c92409">exactly_visual</a>, <a class="el" href="namespaceosim2urdf__parser.html#a985b7dbc4e56a68aee3e904a61c2371b">exactly_collision</a>,<a class="el" href="namespaceosim2urdf__parser.html#a02e8f4b0e11846d789ef52456f89e4af">correc_stl_dic</a>,verbose = True,xacro=True)</td></tr>
<tr class="memdesc:a7158fb745d46e2beedea849918833689"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor of the <a class="el" href="classosim2urdf__parser_1_1Osim2URDF.html" title="Transform a .osim file into a .urdf file. ">Osim2URDF</a> class.  <a href="#a7158fb745d46e2beedea849918833689">More...</a><br /></td></tr>
<tr class="separator:a7158fb745d46e2beedea849918833689"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a556bc2189083b93f7852f14b81846c90"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a556bc2189083b93f7852f14b81846c90">osim_path</a> = '/home/auctus/Documents/OpenSim/4.2-2020-11-24-d9c8bb2c/Models/Arm7'</td></tr>
<tr class="memdesc:a556bc2189083b93f7852f14b81846c90"><td class="mdescLeft">&#160;</td><td class="mdescRight">The path to the .osim model.  <a href="#a556bc2189083b93f7852f14b81846c90">More...</a><br /></td></tr>
<tr class="separator:a556bc2189083b93f7852f14b81846c90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8161856d320b780394891de051cc0133"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a8161856d320b780394891de051cc0133">ros_package_path</a> = &quot;/home/auctus/catkin_ws/src/human_control/&quot;</td></tr>
<tr class="memdesc:a8161856d320b780394891de051cc0133"><td class="mdescLeft">&#160;</td><td class="mdescRight">Path to the ros package.  <a href="#a8161856d320b780394891de051cc0133">More...</a><br /></td></tr>
<tr class="separator:a8161856d320b780394891de051cc0133"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a1ad1e94acfcc8c3b00d794d52d7e75"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceosim2urdf__parser.html#a0a1ad1e94acfcc8c3b00d794d52d7e75">vtp_path</a> = '/home/auctus/Documents/OpenSim/4.2-2020-11-24-d9c8bb2c/Models/Arm7/Geometry'</td></tr>
<tr class="memdesc:a0a1ad1e94acfcc8c3b00d794d52d7e75"><td class="mdescLeft">&#160;</td><td class="mdescRight">Path to the vtp files.  <a href="#a0a1ad1e94acfcc8c3b00d794d52d7e75">More...</a><br /></td></tr>
<tr class="separator:a0a1ad1e94acfcc8c3b00d794d52d7e75"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a27d2053729ad17e5d5c5dd3aa4ae74a4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a27d2053729ad17e5d5c5dd3aa4ae74a4">&#9670;&nbsp;</a></span>readJoint()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def osim2urdf_parser.readJoint </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>name_joint</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>pymodel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>bodies</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>body_name</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read all joints of type "name_joint" belonging to body object "bodies", of name "body_name". </p>
<p>Add all the useful informations to pymodel.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name_joint</td><td>: String. Type of the considered joints.</td></tr>
    <tr><td class="paramname">pymodel</td><td>: Dictionary of List. Dictionary containing every useful informations about the .osim file, in order to convert this file into a .urdf format.</td></tr>
    <tr><td class="paramname">bodies</td><td>: ElementTree. Object Element, containing the informations of the selected body. </td></tr>
    <tr><td class="paramname">body_name</td><td>: String. Name of the body part, representing the child body of the joint.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pymodel : Dictionary of List. The pymodel object with the informations of the considered joint. </dd></dl>

</div>
</div>
<a id="a80361136bd7e3bc9e7ece1768118a430"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a80361136bd7e3bc9e7ece1768118a430">&#9670;&nbsp;</a></span>readJointSet()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def osim2urdf_parser.readJointSet </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>root</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>pymodel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Special case where the .osim file got a "JointSet" tag. </p>
<p>This means that the definition of joints and the definition of body parts of the model are separated. Thus, they need to be treated separately.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">root</td><td>: ElementTree Object. Object containing all informations about the .osim file. Those informations are organized as a tree.</td></tr>
    <tr><td class="paramname">pymodel</td><td>: Dictionary of List. Dictionary containing every useful informations about the .osim file, in order to convert this file into a .urdf format.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pymodel : Dictionary of List. The pymodel object with the informations into the &lt;JointSet&gt; tag of the .osim. </dd></dl>

</div>
</div>
<a id="a49fac8e7a12c5b6df7b7ab737e06cf4e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a49fac8e7a12c5b6df7b7ab737e06cf4e">&#9670;&nbsp;</a></span>readOsim()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def osim2urdf_parser.readOsim </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>First method called to read .osim files. </p>
<p>it first determines the version of the file, in order to determine which parser should be used.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>: String. Path to the .osim file.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pymodel : Dictionary of List. Dictionary containing every useful informations about the .osim file, in order to convert this file into a .urdf format. </dd></dl>

</div>
</div>
<a id="a11cecbea7159fc52d0581507d386b705"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a11cecbea7159fc52d0581507d386b705">&#9670;&nbsp;</a></span>readOsim30()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def osim2urdf_parser.readOsim30 </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Based on the method readOsim of the Ospi package, this method is improved in order to be able to read a larger number of .osim files. </p>
<p>This method is specific to .osim files of version 3.0 or lower.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>: String. Path to the .osim file.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pymodel : Dictionary of List. Dictionary containing every useful informations about the .osim file, in order to convert this file into a .urdf format. </dd></dl>

</div>
</div>
<a id="ad1c7b3a585da1da7552f82ba917b2462"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad1c7b3a585da1da7552f82ba917b2462">&#9670;&nbsp;</a></span>readOsim40()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def osim2urdf_parser.readOsim40 </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Based on the method readOsim of the Ospi package, this method is improved in order to be able to read a larger number of .osim files. </p>
<p>This method is specific to .osim files of version 4.0 or higher.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>: String. Path to the .osim file.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pymodel : Dictionary of List. Dictionary containing every useful informations about the .osim file, in order to convert this file into a .urdf format. </dd></dl>

</div>
</div>
<a id="aeea41d0e48e9cd3fdc78c3e05b200ab5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeea41d0e48e9cd3fdc78c3e05b200ab5">&#9670;&nbsp;</a></span>readVisuals40()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def osim2urdf_parser.readVisuals40 </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>pymodel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>bodies</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Method used to read visual information of a body part "bodies" (linked to the geometry file used to represent the body part : name of the geometry part, scale factors, ...). </p>
<p>To do so, this method reads the tags from the body part of the .osim file usually associated with the visual information.</p>
<p>This method is specific to .osim files of version 4.0 or higher.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">bodies</td><td>: ElementTree. Object Element, containing the informations of the selected body.</td></tr>
    <tr><td class="paramname">pymodel</td><td>: Dictionary of List. Dictionary containing every useful informations about the .osim file, in order to convert this file into a .urdf format.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pymodel : Dictionary of List. The pymodel object with the visual informations of the body part. </dd></dl>

</div>
</div>
<a id="a26ad97fd20c03ddf7aae5cb9f17a385a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a26ad97fd20c03ddf7aae5cb9f17a385a">&#9670;&nbsp;</a></span>readVisualsName40()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def osim2urdf_parser.readVisualsName40 </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>visuals_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>bones_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>bodies</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Method used to read visual informations, written under a tag "name", of a body part "bodies". </p>
<p>This method is specific to .osim files of version 4.0 or higher.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>: String. Name of the visual tag currently being analysed.</td></tr>
    <tr><td class="paramname">visuals_data</td><td>: Dictionary of List. Dictonnary containing the general visual informations of all geometric files of the body part. (Sometimes the scale factors is generalised to all geometry_file of the body part. In this case, this information is recorded here. )</td></tr>
    <tr><td class="paramname">bones_data</td><td>: Dictionary of List. Dictonnary containing specific visual informations of each geometric files of the body part.</td></tr>
    <tr><td class="paramname">bodies</td><td>: ElementTree. Object Element, containing the informations of the selected body.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>visuals_data : Dictionary of List. The visuals_data Dictionary containing the visual informations of the selected body, under the "name" tag.</dd>
<dd>
bones_data : Dictionary of List. The bones_data Dictionary containing the visual informations of the selected body, under the "name" tag. </dd></dl>

</div>
</div>
<a id="a0be355dde18c1660f40705263e2d56a5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0be355dde18c1660f40705263e2d56a5">&#9670;&nbsp;</a></span>VTP2STL()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def osim2urdf_parser.VTP2STL </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>path_vtp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>path_stl</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="a02e8f4b0e11846d789ef52456f89e4af"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a02e8f4b0e11846d789ef52456f89e4af">&#9670;&nbsp;</a></span>correc_stl_dic</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dictionary correc_stl_dic</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Used to correct the positions of the .stl files. </p>

</div>
</div>
<a id="a985b7dbc4e56a68aee3e904a61c2371b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a985b7dbc4e56a68aee3e904a61c2371b">&#9670;&nbsp;</a></span>exactly_collision</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool exactly_collision = False</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>True : try to represent the collision aspect of the model from the .stl files. </p>
<p>False : use approximations according to the dimensions of the .stl file. </p>

</div>
</div>
<a id="ab77d3043b16b1f346c6f99a984c92409"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab77d3043b16b1f346c6f99a984c92409">&#9670;&nbsp;</a></span>exactly_visual</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool exactly_visual = True</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>True : try to represent the visual aspect of the model from the .stl files. </p>
<p>False : use approximations according to the dimensions of the .stl file. </p>

</div>
</div>
<a id="a3a1a90139c2c8ab1fca0ea8b1790b7b2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3a1a90139c2c8ab1fca0ea8b1790b7b2">&#9670;&nbsp;</a></span>filename</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string filename = 'TwoArm_7ddOS4.osim'</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Name of the .osim file. </p>

</div>
</div>
<a id="a7158fb745d46e2beedea849918833689"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7158fb745d46e2beedea849918833689">&#9670;&nbsp;</a></span>o2u</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">o2u = <a class="el" href="classosim2urdf__parser_1_1Osim2URDF.html">Osim2URDF</a>(<a class="el" href="namespaceosim2urdf__parser.html#a556bc2189083b93f7852f14b81846c90">osim_path</a>, <a class="el" href="namespaceosim2urdf__parser.html#a0a1ad1e94acfcc8c3b00d794d52d7e75">vtp_path</a>, <a class="el" href="namespaceosim2urdf__parser.html#a3a1a90139c2c8ab1fca0ea8b1790b7b2">filename</a>, <a class="el" href="namespaceosim2urdf__parser.html#a8161856d320b780394891de051cc0133">ros_package_path</a>, <a class="el" href="namespaceosim2urdf__parser.html#ab77d3043b16b1f346c6f99a984c92409">exactly_visual</a>, <a class="el" href="namespaceosim2urdf__parser.html#a985b7dbc4e56a68aee3e904a61c2371b">exactly_collision</a>,<a class="el" href="namespaceosim2urdf__parser.html#a02e8f4b0e11846d789ef52456f89e4af">correc_stl_dic</a>,verbose = True,xacro=True)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor of the <a class="el" href="classosim2urdf__parser_1_1Osim2URDF.html" title="Transform a .osim file into a .urdf file. ">Osim2URDF</a> class. </p>

</div>
</div>
<a id="a556bc2189083b93f7852f14b81846c90"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a556bc2189083b93f7852f14b81846c90">&#9670;&nbsp;</a></span>osim_path</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string osim_path = '/home/auctus/Documents/OpenSim/4.2-2020-11-24-d9c8bb2c/Models/Arm7'</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The path to the .osim model. </p>

</div>
</div>
<a id="a8161856d320b780394891de051cc0133"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8161856d320b780394891de051cc0133">&#9670;&nbsp;</a></span>ros_package_path</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string ros_package_path = &quot;/home/auctus/catkin_ws/src/human_control/&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Path to the ros package. </p>

</div>
</div>
<a id="a0a1ad1e94acfcc8c3b00d794d52d7e75"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0a1ad1e94acfcc8c3b00d794d52d7e75">&#9670;&nbsp;</a></span>vtp_path</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string vtp_path = '/home/auctus/Documents/OpenSim/4.2-2020-11-24-d9c8bb2c/Models/Arm7/Geometry'</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Path to the vtp files. </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
